# do not modify this file, use conf.sh instead

basedir="/opt/nana"
coredir="$basedir/core"
netldbdir="$basedir/netldb"
# FHS stuff
etconf="/etc/opt/nana/core/conf.sh"
logdir="/var/log/nana/core"
rundir="/var/run/nana"

# core
user="nana"
golems="dbpipe.sh revisor dispatcher fdb2graph rresolver topology snmp/addresses snmp/agents snmp/dispatcher"

# MySQL
dbhost="nana"
dbname="nana"
dbruser="nanar"
dbrpass="public"
dbwuser="nanaw"
dbwpass="secret"

# for old netldb/usr scripts
mysql_prepinace="-h $dbhost -p$dbrpass -u $dbruser $dbname"

select_opts="-h $dbhost -p$dbrpass -u $dbruser $dbname -Ns"
modify_opts="-h $dbhost -p$dbwpass -u $dbwuser $dbname"

mysqlwpipe="$rundir/mysqlwpipe"

# SNMP
# used for RRD step and heartbeat
# beware - rrdtool tune is needed after changing this variable
# snmpinterval must be <= 1800 because of hardcoded steps in core/snmp/mib/if.sh
snmpinterval=300
# read access
snmprcommunity=public

# RRD
# comment it out, if you do not use rrdcached
rrdcached="--daemon unix:/var/run/rrdcached/rrdcached.sock"

rrddir="/var/opt/nana/rrd"
# must be writable by $user above
rrdstatsdir="$rrddir/stats"

# commands
#digptr="dig +noall +answer -x"

# functions?

# at the very end load the user configuration

# older user config; leaved here for backward compatibility
# $confdir is set in sourcing script
config=$confdir/conf.sh
test -f "$config" && source "$config"

# this user config overrides all previous
test -f "$etconf" && source "$etconf"

# send ok to the sourcing script (defaults.sh)
true
