#!/bin/bash
# Copyright 2014 - 2019 Michal Žejdl

confdir=$(dirname $0)/../core
config=$confdir/defaults.sh
test -f "$config" || exit
source "$config" || exit

echo "creating system user $user"
# -m is for /home dir and it is for "su -" - see init.sh
useradd -m -r $user
# rights to the socket
usermod -a -G rrdcached $user
# rights to the RRD files
usermod -a -G $user rrdcached

# make user config readable by the newly created group
if test -f "$etconf"
then
	chgrp "$user" "$etconf"
	chmod g=r,o= "$etconf"
fi
