#!/bin/bash
# Copyright 2018 Michal Žejdl
# fill the ieee_ma_* tables from local *.csv files

# dependencies
for program in mysql
do
	which "$program" >/dev/null || exit
done

mydir=$(dirname $0)

confdir=$mydir/../core
config=$confdir/defaults.sh
test -f $config || exit
source $config || exit

l=oui.csv
m=mam.csv
s=oui36.csv
i=iab.csv

if test -s "$l"
then
	mysql -e "drop table if exists ieee_ma_l" $modify_opts
	# the MA-L has 3 non unique assignments, so no primary key here
	mysql -e "
	create table ieee_ma_l (
			prefix char(6) not null,
			name varchar(255) not null,
			address varchar(255),
			key (prefix)
			)
	" $modify_opts
	mysql -e "
	load data local infile '$l'
	into table ieee_ma_l
	character set utf8
	fields terminated by ',' optionally enclosed by '\"'
	lines starting by 'MA-L,' terminated by '\r\n'
	ignore 1 lines
	" $modify_opts
fi

if test -s "$m"
then
	mysql -e "drop table if exists ieee_ma_m" $modify_opts
	mysql -e "
	create table ieee_ma_m (
			prefix char(7) not null,
			name varchar(255) not null,
			address varchar(255),
			primary key (prefix)
			)
	" $modify_opts
	mysql -e "
	load data local infile '$m'
	into table ieee_ma_m
	character set utf8
	fields terminated by ',' optionally enclosed by '\"'
	lines starting by 'MA-M,' terminated by '\r\n'
	ignore 1 lines
	" $modify_opts
fi

if test -s "$s" -o -s "$i"
then
	mysql -e "drop table if exists ieee_ma_s" $modify_opts
	mysql -e "
	create table ieee_ma_s (
			prefix char(9) not null,
			name varchar(255) not null,
			address varchar(255),
			primary key (prefix)
			)
	" $modify_opts

	if test -s "$i"
	then
		mysql -e "
		load data local infile '$i'
		into table ieee_ma_s
		character set utf8
		fields terminated by ',' optionally enclosed by '\"'
		lines starting by 'IAB,' terminated by '\r\n'
		ignore 1 lines
		" $modify_opts
	fi

	if test -s "$s"
	then
		mysql -e "
		load data local infile '$s'
		into table ieee_ma_s
		character set utf8
		fields terminated by ',' optionally enclosed by '\"'
		lines starting by 'MA-S,' terminated by '\r\n'
		ignore 1 lines
		" $modify_opts
	fi
fi
