#!/bin/bash
# Copyright 2008 - 2018 Michal Žejdl
# update tabulky checked tak, aby se dlouho nečekalo na novinky

confdir=$(dirname $0)/../core
config=$confdir/defaults.sh
test -f $config || exit
. $config

# nejmladší z arp (z fdb ne, tam jsou i MAC bez IP), co není v checked
# a zároveň je nejmladší recyklovaná IP (aby se na použité IP nevázaly jejich
# staré MAC)
# dotaz dodal Michal Zaschke
#nova="select mac from arp where not exists (select null from checked where checked.mac=arp.mac) and time=(select max(time) from arp where not exists (select null from checked where checked.mac=arp.mac)) limit 1"
#nova="select mac from arp where not exists (select null from checked where checked.mac=arp.mac) and time=(select max(time) from arp where not exists (select null from checked where checked.mac=arp.mac)) and not exists (select null from arp arp2 where arp.ip = arp2.ip and arp.time < arp2.time) limit 1"
nova="select mac from arp where not exists (select null from checked where checked.mac=arp.mac) and not exists (select null from arp arp2 where arp.ip = arp2.ip and arp.time < arp2.time) and time=(select max(time) from arp arp2 where arp.mac=arp2.mac and not exists (select null from checked where checked.mac=arp2.mac)) order by time desc limit 1"

# nejstarší kontrolovaná oživlá, co měla SNMP (např. přepínače s výpadky)
ozivla_s_snmp="select mac from arp join checked using(mac) where live = 'n' and snmp = 'y' and time > lastcheck order by lastcheck limit 1"

# nejstarší kontrolovaná živá s SNMP - kvůli update DNS
ziva_s_snmp="select mac from checked where live = 'y' and snmp = 'y' order by lastcheck limit 1"

# nejstarší kontrolovaná oživlá
ozivla="select mac from arp join checked using(mac) where live = 'n' and time > lastcheck order by lastcheck limit 1"

# nejstarší kontrolovaná živá
ziva="select mac from checked where live = 'y' order by lastcheck limit 1"

# nejstarší kontrolovaná
nejstarsi="select mac from checked order by lastcheck limit 1"

while true; do
  for i in "$nova" "$ozivla_s_snmp" "$ziva_s_snmp" "$ozivla" "$ziva" "$nejstarsi"; do
  	# stop this golem if "šém" is removed
	test -e $rundir/$(basename $0 .sh).sem || exit
    time=$(date +'%F %T')
    if ! mac=$(mysql -e "$i" $modify_opts -s); then
      echo "$time nějaký problém s db"
    else
      if test -z $mac; then
        echo "$time prázdná odpověď na dotaz"
      else
        echo "$time zkoumám $mac"
        $netldbdir/checker.sh $mac
      fi
    fi
	sleep 1
  done
done
