#!/bin/bash
# Copyright 2018 Michal Žejdl
# more generic graph creation

# check number of arguments
test $# -lt 7 && exit

rrdbasedir=$1
rrdfile=$2
outputdir=$3
starttime=$4
endtime=$5
title=$6
vlabel=$7

# make the remote flush possible
cd $rrdbasedir || exit

test -d "$outputdir" || mkdir -p "$outputdir" || exit

# lazy (-z) is handy
options="-s $starttime -e $endtime -z"

# append rrdcached
test $# -gt 7 && options="$options --daemon $8"

filename=$(basename $rrdfile .rrd)

rrdtool graph \
$outputdir/$filename-$starttime-$endtime.png \
$options -t "$title" -v "$vlabel" \
DEF:aa=$rrdfile:a:AVERAGE \
DEF:an=$rrdfile:a:MIN \
DEF:am=$rrdfile:a:MAX \
DEF:al=$rrdfile:a:LAST \
VDEF:aaa=aa,AVERAGE \
VDEF:ann=an,MINIMUM \
VDEF:amm=am,MAXIMUM \
VDEF:all=al,LAST \
TEXTALIGN:left \
LINE2:aa#0000cc:"  " \
GPRINT:aaa:"avg\: %6.2lf %s" \
GPRINT:ann:"min\: %6.2lf %s" \
GPRINT:amm:"max\: %6.2lf %s" \
GPRINT:all:"lst\: %6.2lf %s\l"
