<?php

/*
 * Copyright 2016 - 2018 Michal Žejdl
 */

$document_root = "../..";

require "$document_root/init.php";

$title = "3Com hwDevice MIB";

page_open($document_root, $title);


// enable debug_print()
//$debug = true;

// init db
$connection = mysql_connect($dbhost, $dbuser, $dbpass);
if (!$connection) exit;
mysql_select_db($dbname);

if (isset($_GET["agent"])) {
	$snmpagentid = $_GET["agent"];
	// validity check
	if (!preg_match("/^[[:digit:]]+$/", $snmpagentid)) exit;

	/*
	// start is not required
	if (isset($_GET["start"]) 
			and preg_match("/^[[:alnum:]-]+$/", $_GET["start"]))
		$start = $_GET["start"];
	// PHP automagicaly initializes variables from URL
	else unset($start);
	
	// end is not required
	if (isset($_GET["end"])
			and preg_match('/^[[:alnum:]-]+$/', $_GET["end"]))
		$end = $_GET["end"];
	else unset($end);
	*/

	print_snmp_header($document_root, $snmpagentid);

	echo "<h2>$title</h2>\n";

	/*
	// the form above tests $end presence; now we can initialize it
	if (!isset($end)) $end = "now";
	*/

	// common variables for RRD graphs
	$thisdir = dirname(__FILE__);
	$bindir = $thisdir . "/../../bin";
	$outputdir = "imgcache/" . $snmpagentid;
	if (!is_dir($outputdir))
		if (!mkdir($outputdir, 0777, true))
			exit("<p>mkdir($outputdir) failed");

	$rrdfile = "snmpagent/" . $snmpagentid . "/3Com/hwDevice.rrd";

	/*
	if (isset($start)) $starts = array($start);
	else $starts = array("now-1d", "now-1w", "now-1m", "now-1y");
	*/

	$end = get_end();
	$start = get_start($end);
	print_start_end_selector($start, $end);

	$filename = $rrdbasedir . "/" . $rrdfile;

	if (file_exists($filename) and !is_rrd_obsolete($filename, $start)) {

		//foreach ($starts as $start) {
		$command = "$bindir/graph-3com.sh"
			. " $rrdbasedir $rrdfile"
			. " $thisdir/$outputdir $start $end";
		if (! empty($rrdcached))
			$command .= " $rrdcached";
		debug_print($command);
		exec($command);

		echo "<p class=\"center\">\n";
		echo "<img alt=\"CPU\"",
		     " src=\"$outputdir/",
		     "3com-cpu-$start-$end.png\">";
		echo "<img alt=\"mem\"",
		     " src=\"$outputdir/",
		     "3com-mem-$start-$end.png\">";
		echo "<br>\n";
		//}
	}

} else {
	// agent is not set - show all live agents

	echo "<h1>";
	echo gettext("all known recently live 3Com devices");
	echo "</h1>\n";

	if (isset($_GET["order"]))
		$order = $_GET["order"];
	else $order = "name";

	switch ($order) {
		case "name":
			$order_by = "sysName";
			break;
		case "time":
			$order_by = "time";
			break;
		case "entPhysicalDescr":
			$order_by = "entPhysicalDescr";
			break;
		case "entPhysicalFirmwareRev":
			$order_by = "entPhysicalFirmwareRev";
			break;
		case "entPhysicalSoftwareRev":
			$order_by = "entPhysicalSoftwareRev";
			break;
		default:
			$order_by = "sysName";
	}

	//$debug = true;
	debug_print("$order_by");

	$result = mysql_query("select
			sysName, agent, entPhysical.time time,
			entPhysicalDescr,
			entPhysicalFirmwareRev,
			entPhysicalSoftwareRev
			from snmpagent join entPhysical on id = agent
			where
			sysObjectID like '.1.3.6.1.4.1.43.%'
			and entPhysical.time > unix_timestamp() - 7 * 86400
			and entPhysicalClass = 3
			order by $order_by");

	//$debug = true;

	echo "<table summary=\"", gettext("3Com devices"), "\">\n";
	$anchor = "<a href=\"?order=";
	echo "<tr>",
	     "<th>", $anchor, "name", "\">", "sysName",
	     "<th>", $anchor, "time", "\">", "time",
	     "<th>", $anchor, "entPhysicalDescr", "\">", "entPhysicalDescr",
	     "<th>", $anchor, "entPhysicalFirmwareRev", "\">", "Firmware",
	     "<th>", $anchor, "entPhysicalSoftwareRev", "\">", "Software",
	     "\n";

	$row_number = 0;
	$timestamp = time();

	while ($row = mysql_fetch_array($result)) {
		echo "<a name=\"", $row["agent"], "\"></a>";
		echo "<tr class=\"monospace ",
		     tr_aging_class(++$row_number, $timestamp - $row["time"]),
		     "\">";

		echo "<td>";
		print_link_to_agent("3Com.php?agent=", $row["agent"],
				$row["sysName"]);

		echo "<td>", date_formated($row["time"]),
		     "<td>", $row["entPhysicalDescr"],
		     "<td>", $row["entPhysicalFirmwareRev"],
		     "<td>", $row["entPhysicalSoftwareRev"],
		     "\n";
	}
	echo "</table>\n";

	echo "<h2>", gettext("legend"), "</h2>\n";

	echo "<p>", gettext("columns are sorted by click on their names"), "\n";

	echo "<ul>\n";
	echo "<li>sysName - ", gettext("system MIB entry"), "\n";
	echo "<li>time - ", gettext("time of reading the entity MIB"), "\n";
	echo "<li>Firmware - entPhysicalFirmwareRev\n";
	echo "<li>Software - entPhysicalSoftwareRev\n";
	echo "</ul>\n";
}



page_close($document_root);

?>
